---
- name: check if the is a certificates already
  shell: "oc --config={{ dest_kubeconfig }} get secret -n openshift-ingress | grep 'custom-certs-default'"
  ignore_errors: yes
  register: certs_true

- block:
    - name: create temp directory
      tempfile:
        suffix: build
        state: directory
      register: tempdir
    
    - name: fetch rootCA files
      get_url:
        url: "https://raw.githubusercontent.com/matancarmeli7/cloudlet/master/ca/{{ item }}"
        dest: "{{ tempdir.path }}/{{ item }}"
        remote_src: yes
      with_items:
        - rootCA.key
        - rootCA.srl
        - rootCA.pem
    
    - name: generate private key for api and apps
      shell: "openssl genrsa -out {{ tempdir.path }}/{{ item }}.key 2048"
      with_items:
        - api
        - apps
    
    - name: generate csr for api
      shell: "openssl req -new -key {{ tempdir.path }}/{{ item }}.key -out {{ tempdir.path }}/{{ item }}.csr -subj \"/CN=api.{{ cluster_name }}.{{ base_domain }}\""
      with_items:
        - api
    
    - name: generate csr for apps
      shell: "openssl req -new -key {{ tempdir.path }}/{{ item }}.key -out {{ tempdir.path }}/{{ item }}.csr -subj \"/CN=*.apps.{{ cluster_name }}.{{ base_domain }}\""
      with_items:
        - apps
    
    - name: generate crt for api and apps
      shell: "openssl x509 -req -in {{ tempdir.path }}/{{ item }}.csr -CA {{ tempdir.path }}/rootCA.pem -CAkey {{ tempdir.path }}/rootCA.key -CAcreateserial -out {{ tempdir.path }}/{{ item }}.crt -days 825 -sha256"
      with_items:
        - api
        - apps
        
    - name: set path to tempdir
      set_fact:
        path_tempdir: "{{ tempdir.path }}"
    
    - name: create temp directory in apache server
      file:
        path: /var/www/html/ocp4-certificates/{{ cluster_name }}
        state: directory
      register: web_dir
      delegate_to: "{{ ocp_web }}"
      remote_user: cloudlet
      become: true
      become_method: sudo

    - name:
      copy:
        src: "{{ tempdir.path }}/{{ item }}"
        dest: "{{ web_dir.path }}"
      delegate_to: "{{ ocp_web }}"
      remote_user: cloudlet
      become: true
      become_method: sudo
      with_items:
        - api.crt
        - api.key
        - apps.crt
        - apps.key
  when: 'openshift_custom_certificates and certs_true.stdout==""'